package view;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import model.Driver;
import model.Sieve;
import processing.core.PApplet;
import processing.core.PFont;

@SuppressWarnings("serial")
public class Main extends PApplet {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		PApplet.main(new String[] {"view.Main"});
		try {
			Thread.sleep(1000);

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	
		Driver.main(args);
	}

	private Map<Sieve,VSieve> sieves = new ConcurrentHashMap<Sieve, VSieve>();
	private Map<Integer,VNumber> numbers = new ConcurrentHashMap<Integer, VNumber>();
	private VSieve firstSieve;

	@Override
	public void draw() {
		//paint background
		fill(128); rect(0,0,width,height);
		for (VSieve a : sieves.values()) 
			a.draw(this);
		for (VNumber a : numbers.values()) 
			a.draw(this);
		
	}

	@Override
	public void setup() {
		if (frame!=null)
			frame.setResizable(true);
		size(1000,800);
		noStroke();
		PFont font = createFont("MS PGothic", 50);
		textFont(font,40);
		textAlign(CENTER);
		if (frame==null) {
			new Thread(){

				@Override
				public void run() {
					Driver.main(null);
				}
				
			}.start();
		}
//		final VSieve s = new VSieve(width+100,100);
//		s.setPrime(99);
//		sieves.put(new Sieve(),s);
	}


	@Override
	public void mouseClicked() {
		// do nothing
	}

	public void add(Sieve s, VSieve vs) {
		if (firstSieve==null)
			firstSieve=vs;
		sieves.put(s,vs);
	}

	public VSieve getFirstVSieve() {
		return firstSieve;
	}

	public void add(VNumber n) {
		numbers.put(n.getNumber(), n);
	}

	public VNumber getVNumber(int n) {
		return numbers.get(n);
	}

	public VSieve getVSieve(Sieve dest) {
		return sieves.get(dest);
	}

	public void removeVNumber(int n) {
		numbers.remove(n);
	}
}
