package view;

import processing.core.PApplet;

public class VExplosion {
	private static final int NUM_PARTICLES = 100;
	private static final int RADIUS = 30;
	private static final int FPS = 30;
	private static final double GRAVITY = 2;
	private int x;
	private int y;
	private double[] px = new double[NUM_PARTICLES], py = new double[NUM_PARTICLES];
	private double[] vx = new double[NUM_PARTICLES], vy = new double[NUM_PARTICLES];

	public VExplosion(int x, int y) {
		this.x = x; this.y =y;
		for (int i = 0; i < NUM_PARTICLES; i++) {
			px[i] = 0;//
			py[i] = 0;//(int) (Math.random()*RADIUS);
			vx[i] =  (Math.random()*RADIUS/2) - RADIUS/4;
			vy[i] =  (Math.random()*RADIUS/2) - RADIUS/4;
		}
	}

	public void draw(PApplet canvas) {
		for (int i = 0; i < NUM_PARTICLES; i++) {
			canvas.fill(0xffff0000);
			canvas.ellipse((int)(x+px[i]), (int)(y+py[i]), 5, 5);
		}		
	}

	public void explode(int timeLength) {
		long endTime = System.currentTimeMillis() + timeLength;
		while (System.currentTimeMillis() < endTime) {
			for (int i = 0; i < NUM_PARTICLES; i++) {
				px[i] += vx[i];//
				py[i] += vy[i];//(int) (Math.random()*RADIUS);
				vy[i] += GRAVITY;
			}
			try {
				Thread.sleep(1000/FPS);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}
	
	
}
