package view;

import processing.core.PApplet;

public class VNumber extends Actor {

	private int interval = 500;
	private static final int FRAME_RATIO = 30;

	private int textColor = 0xffffff00;
//	private static final int SIZE = VSieve.SIZE;
	private int number;

	public int getNumber() {
		return number;
	}

	private int centerX;
	private int centerY;
	private int goalX;
	private int goalY;;
	private int goalColor;
	private VExplosion explosion;

	public VNumber(VSieve s, int number) {
		this.centerX = this.goalX = s.getCenterX() - SIZE;
		this.centerY = this.goalY = s.getCenterY();
		this.number = number;
	}

	public void drawBody(PApplet canvas) {
		if (explosion!=null)
			explosion.draw(canvas);
		else {
			canvas.fill(textColor);
			canvas.text("" + number, centerX, centerY + SIZE / 2);
		}
	}

	protected void move(int timeLength, boolean stopMiddle) {
		long startTime = System.currentTimeMillis();
		long goalTime = startTime + timeLength;
		long startX = this.centerX;
		long dX = goalX - startX;
		long mX = startX + dX/2;
		long startY = this.centerY;
		long startColor = textColor;
		double fdx = stopMiddle ? 0.5 : 1;
		for (long now=startTime; goalTime > now; now = System.currentTimeMillis()) {
			double progress = 1.0 * (now - startTime) / timeLength;
			int newX = (int) ((goalX - startX) * progress * fdx + startX);
			int newY = (int) (((goalY - startY) * progress + startY)
						+ 4*(newX-mX)*(newX-mX)/dX -dX);
			synchronized (this) {
				this.centerX = newX;
				this.centerY = newY;
				this.textColor = (int) ((goalColor - startColor) * progress + startColor);
			}
			try {
				Thread.sleep(1000 / FRAME_RATIO);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
//		synchronized (this) {
//			this.centerX = goalX;
//			this.centerY = goalY;
//		}
	}

	public void moveTo(VSieve goal) {
		goalX = goal.getCenterX() - SIZE;
		goalY = goal.getCenterY();
		goalColor = textColor;
		move(interval, false);
	}

	public void diveTo(VSieve goal) {
		goalX = goal.getCenterX() + SIZE;
		goalY = goal.getCenterY();
		goalColor = textColor; // 0x00ffff00;
		move(interval / 2, true);
		explosion = new VExplosion(this.centerX, this.centerY);
		explosion.explode(interval/2);
	}

	@Override
	int xOffset() {
		return centerX;
	}

}
